<?php

namespace SM\Controller;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\FmRelatoriosOperacionalContratoService;
use SM\Traits\TResponse;

class FmRelatoriosOperacionalContratoController
{

    use TResponse;

    protected $FmRelatoriosOperacionalContratoService;

    public function __construct(FmRelatoriosOperacionalContratoService $FmRelatoriosOperacionalContratoService)
    {
        $this->FmRelatoriosOperacionalContratoService = $FmRelatoriosOperacionalContratoService;
    }

    /* Inicio TAB relatórios tarefas */
    public function getRelatoriosTarefas()
    {
        try {
            $data = $this->FmRelatoriosOperacionalContratoService->getRelatoriosTarefas();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getItensTarefas(Request $request)
    {
        try {
            $data = $this->FmRelatoriosOperacionalContratoService->getItensTarefas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFotosTarefas(Request $request)
    {
        try {
            $data = $this->FmRelatoriosOperacionalContratoService->getFotosTarefas($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFiltroRelatorioLocal()
    {
        try {
            $data = $this->FmRelatoriosOperacionalContratoService->getFiltroRelatorioLocal();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFiltroRelatorioCliente()
    {
        try {
            $data = $this->FmRelatoriosOperacionalContratoService->getFiltroRelatorioCliente();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    /* Fim TAB relatórios tarefas */
    
    /* Estrutura da Hierarquia do Facilities */
    public function findOperadorHierarq(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FmRelatoriosOperacionalContratoService->findOperadorHierarq($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    private function getFiltro($request)
    {
        if (isset($request->getParameters()["find"])) {
            $filtro = $request->getParameters()["find"];
        } else {
            $filtro = '';
        }
        return $filtro;
    }

    /* Inicio TAB relatórios Vistorias */
    public function getRelatoriosVistoria()
    {
        try {
            $data = $this->FmRelatoriosOperacionalContratoService->getRelatoriosVistoria();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFiltroVistoriaSituacao()
    {
        try {
            $data = $this->FmRelatoriosOperacionalContratoService->getFiltroVistoriaSituacao();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCriteriosVistoria(Request $request)
    {
        try {
            $data = $this->FmRelatoriosOperacionalContratoService->getCriteriosVistoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFotosVistoria(Request $request)
    {
        try {
            $data = $this->FmRelatoriosOperacionalContratoService->getFotosVistoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    /* Fim TAB relatórios Vistorias */

    /* Inicio TAB relatórios auditorias */
    public function getTarefasAuditoria()
    {
        try {
            $data = $this->FmRelatoriosOperacionalContratoService->getTarefasAuditoria();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCategoriasAuditoriaRelatorio(Request $request)
    {
        try {
            $data = $this->FmRelatoriosOperacionalContratoService->getCategoriasAuditoriaRelatorio($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTopicosAuditoriaExecRelatorio(Request $request)
    {
        try {
            $data = $this->FmRelatoriosOperacionalContratoService->getTopicosAuditoriaExecRelatorio($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCriteriosAuditoriaExecRelatorio(Request $request)
    {
        try {
            $data = $this->FmRelatoriosOperacionalContratoService->getCriteriosAuditoriaExecRelatorio($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function getImagensTopicosAuditoria(Request $request)
    {
        try {
            $data = $this->FmRelatoriosOperacionalContratoService->getImagensTopicosAuditoria($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    /* Fim TAB relatórios auditorias */
}
