/* eslint-disable */
import {
    IEventParam,
    Metadata,
} from '@zeedhi/core';
import {
    Button, ModalService, Modal, Form, TextInput, Date, LoadingService,
    Tabs,
} from '@zeedhi/common';
import { TekGrid, TekTreeGrid } from '@zeedhi/teknisa-components-common';

export class Sm00001002PropostaHistoricoController {
    private basicModal!: Modal;

    public textModal: string = '';

    public visibilidade: boolean = true;

    public visibleFrame: boolean = false;

    private clicks: any = 0;

    public currentRow: any = {};

    get visibilidadeDoFrame() {
        return !this.visibilidade;
    }

    public openFilter({ component }: any) {
        const filterButton = Metadata.getInstance<Button>(`${component.name}_filterButton`);
        filterButton.click({} as Event, {} as HTMLElement);
    }

    public async exibirModal() {
        this.basicModal = await ModalService.createFromJson('sm_00001_002_proposta_historico/modal/sm_00001_002_proposta_historico_modal', true);
    }

    public vizualizarInformacoesComposicaoServicos({ row }: any) {
        this.visibilidade = false;
        this.currentRow = row;
        this.montarInformacoesOrcamento();
    }

    public voltarPaginaInicial() {
        this.visibilidade = true;
    }

    public montarInformacoesOrcamento() {
        LoadingService.show();
        this.textModal = `Detalhes da Proposta: ${this.currentRow.NRORCAMENTO}`;
        Metadata.getInstance<TextInput>('NRORCAMENTO').value = this.currentRow.NRORCAMENTO;
        Metadata.getInstance<TextInput>('IDSITUACAOORCAMENTO').value = this.currentRow.IDSITUACAOORCAMENTO;
        Metadata.getInstance<Date>('DTREFORCAMENTO').value = this.currentRow.DTREFORCAMENTO;
        Metadata.getInstance<Date>('DTACEITEORCA').value = this.currentRow.DTACEITEORCA;
        Metadata.getInstance<TextInput>('NMORCAMENTOMODELO').value = this.currentRow.NMORCAMENTOMODELO;
        Metadata.getInstance<TextInput>('NMOPERRESPONSAVEL').value = this.currentRow.NMOPERRESPONSAVEL;
        Metadata.getInstance<TextInput>('DSREFERENCIAORCA').value = this.currentRow.DSREFERENCIAORCA;
        Metadata.getInstance<TextInput>('NMPRINCIPALPARC').value = this.currentRow.NMPRINCIPALPARC;
        Metadata.getInstance<TextInput>('NMITEMORCAMENTO').value = this.currentRow.NMITEMORCAMENTO;
        Metadata.getInstance<TextInput>('DSCAMPOALTERADO').value = this.currentRow.DSCAMPOALTERADO;
        Metadata.getInstance<TextInput>('DSVALORANTIGO').value = this.currentRow.DSVALORANTIGO;
        Metadata.getInstance<TextInput>('DSVALORNOVO').value = this.currentRow.DSVALORNOVO;
        Metadata.getInstance<Date>('DTALTERACAO').value = this.currentRow.DTALTERACAO;
        Metadata.getInstance<TextInput>('NMOPERALTERACAO').value = this.currentRow.NMOPERALTERACAO;
        LoadingService.hide();
    }

    public fecharModal() {
        this.basicModal.hide();
    }

    public expandir({ component }: any) {
        const form = Metadata.getInstance<Form>(component.name.split('_')[1]);
        form.isVisible = !form.isVisible;
        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }
}
